Attribute VB_Name = "MainModule"
Option Explicit

Private Declare Function EnumWindows Lib "user32" (ByVal lpEnumFunc As Long, ByVal lParam As Long) As Long
Private Declare Function GetWindowText Lib "user32" Alias "GetWindowTextA" (ByVal hWnd As Long, ByVal lpString As String, ByVal cch As Long) As Long

Public Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long
Public Declare Function IsWindowEnabled Lib "user32" (ByVal hWnd As Long) As Long
Public Declare Function IsWindowVisible Lib "user32" (ByVal hWnd As Long) As Long
Public Declare Function GetWindowPlcement Lib "user32" (ByVal hWnd As Long, lpwndpl As WINDOWPLACEMENT) As Long
Public Declare Function FindWindowEx Lib "user32" Alias "FindWindowExA" (ByVal hWnd1 As Long, ByVal hWnd2 As Long, ByVal lpsz1 As String, ByVal lpsz2 As String) As Long

Public Type RECT
        Left As Long
        Top As Long
        Right As Long
        Bottom As Long
End Type

Public Type POINTAPI
        X As Long
        Y As Long
End Type

Public Type WINDOWPLACEMENT
        Length As Long
        flags As Long
        showCmd As Long
        ptMinPosition As POINTAPI
        ptMaxPosition As POINTAPI
        rcNormalPosition As RECT
End Type

Public Type WindowStatus
        Caption As String
        ClassName As String
        hWnd As Long
End Type

Public Const LB_SETHORIZONTALEXTENT = &H194
Public Const WM_CLOSE = &H10

Public ObjectStatusList() As WindowStatus
Public WindowStatusList() As WindowStatus
Public WindowNumber As Integer

Private Function CallBackFunction(ByVal hWnd As Long) As Long
Dim WindowCaption As String * 255
Dim WindowCaptionLength As Long
    WindowCaptionLength = GetWindowText(hWnd, WindowCaption, 255)
    If Left(WindowCaption, WindowCaptionLength) <> "" And Left(WindowCaption, WindowCaptionLength) <> "Default IME" Then
        ReDim Preserve WindowStatusList(WindowNumber)
        
        WindowStatusList(WindowNumber).hWnd = hWnd
        
        WindowStatusList(WindowNumber).Caption = Left(WindowCaption, WindowCaptionLength)
        
        WindowNumber = WindowNumber + 1
    End If
    CallBackFunction = True
End Function

Public Sub StartEnumWindows()
Dim i As Integer
    WindowNumber = 0
    frmMain.ListWindow.Clear
    EnumWindows AddressOf CallBackFunction, ByVal 0&
    For i = 0 To UBound(WindowStatusList)
        frmMain.ListWindow.AddItem WindowStatusList(i).Caption
    Next i
End Sub

Public Sub SearchObject(hWnd As Long)
Dim TmphWnd As Long
    Do
        TmphWnd = FindWindowEx(hWnd, TmphWnd, vbNullString, vbNullString)
        If TmphWnd = 0 Then Exit Do
        
        ReDim Preserve ObjectStatusList(WindowNumber)
        ObjectStatusList(WindowNumber).hWnd = TmphWnd
        
        WindowNumber = WindowNumber + 1
        SearchObject TmphWnd
    Loop
End Sub
